/*	acconfig.h
 *
 *	$Id: acconfig.h,v 1.1 2001/04/28 13:13:08 short Exp $
 */

#ifndef TAC_PLUS_CONFIG_H
#define TAC_PLUS_CONFIG_H 1

@TOP@


/* --maintainer-mode
 * Sets "/etc/tacacs/tac_plus.cfg" as default config file
 */
#undef MAINTAINER_MODE

/* Missing socklen_t in <sys/socket.h>
 * We don't use 'typedef' to not to yet require <stddef.h> included here.
 */
#undef socklen_t

/* Define this if you have shadow passwords in /etc/passwd and
 * /etc/shadow. Note that you usually need to be root to read
 * /etc/shadow */
#undef SHADOW_PASSWORDS

/* Check for some fields in <pwd.h>/struct passwd and <utmp.h>/struct utmp
 */
#undef HAVE_PASSWD_PW_AGE
#undef HAVE_PASSWD_PW_COMMENT
#undef HAVE_UTMP_UT_HOST

/* All OSes detected by configure.in:
 */
#undef LINUX
#undef GLIBC
#undef SOLARIS
#undef FREEBSD
#undef HPUX
#undef AIX
#undef MIPS

/* --with-pam */
#undef USE_PAM
/* --with-ldap */
#undef USE_LDAP
/* --with-db */
#undef USE_DB
/* --with-db */
#undef DB_NULL
/* --with-mysql */
#undef DB_MYSQL
/* --with-pgsql */
#undef DB_PGSQL
/* --enable-maxsess */
#undef MAXSESS
/* --with-libwrap */
#undef TCPWRAPPER
/* --with-skey */
#undef SKEY
/* --with-mschap[=des] */
#undef MSCHAP
#undef MSCHAP_DES
/* --with-tac[ug]id */
#undef TACPLUS_USERID
#undef TACPLUS_GROUPID
/* --with-tacplus_pid */
#undef TACPLUS_PIDFILE
/* --with-included-regex */
#undef WITH_INCLUDED_REGEX
/* --enable-finger */
#undef ENABLE_FINGER

@BOTTOM@

/* Keep in sync with configure.in */
#define _XOPEN_SOURCE 1			/* for unistd.h/crypt() */
#define _XOPEN_SOURCE_EXTENDED 1	/* for pwd.h/{set,end}pwent(), sys/wait.h/wait3() */
#define _BSD_SOURCE 1			/* for u_{char,short,int} & string.h/bcopy() */
#define _OSF_SOURCE 1			/* for u_{char,short,int} (on Alpha OSF1) */
#define __EXTENSIONS__ 1		/* for u_{char,short,int} (on Sparc Solaris) */

#if SIZEOF_UNSIGNED_SHORT == 4
typedef unsigned short tac_uint32;
#else
#if SIZEOF_UNSIGNED_INT == 4
typedef unsigned int tac_uint32;
#else
#if SIZEOF_UNSIGNED_LONG == 4
typedef unsigned long tac_uint32;
#else
#error "Unable to find 32-bit unsigned int for TAC_UINT32 type"
#endif /* SIZEOF_UNSIGNED_LONG */
#endif /* SIZEOF_UNSIGNED_INT */
#endif /* SIZEOF_UNSIGNED_SHORT */


#endif	/* TAC_PLUS_CONFIG_H */
