/* 
		This is Database Functions header file 


03-15-2003	Merging of 4.0.10 and 4.3beta

		-------------------------------------------------------------
		Andrew Young (baram01@hotmail.com)
*/

#if defined(USE_DB)

#ifndef _TAC_DB_H_		/* to avoid duplicate definitions */
#define _TAC_DB_H_

/* The databases  recognized by this definition */
#define DEFINED_DB {"null","mysql","pgsql"}

#define SQLCMDL 2048

#define AUTHSQL "SELECT %s, gid FROM %s WHERE %s=\"%s\" and (UNIX_TIMESTAMP(expires)>UNIX_TIMESTAMP() or expires='0')"
#define HOSTAUTHSQL "SELECT %s FROM host WHERE network=(%u&submask) ORDER BY submask DESC"
#define ACCTSQL "INSERT INTO %s (date,nas,uid,terminal,client_ip,type,service,priv_lvl,elapsed_time,bytes_in,bytes_out,cmd) VALUES (NOW(),\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",%s,%s,%s,%s,\"%s\")"
#define ACCESSSQL "INSERT INTO access (date,nas,terminal,uid,client_ip,service,status) VALUES (NOW(),\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\")"
#define USERACCESSSQL "SELECT permission FROM user, acl where acl_id=id and uid in ('%s', '%s') and type=1 and value1=(INET_ATON('%s')&submask)"
#define HOSTACLSQL "SELECT %s FROM host WHERE network=(%u&submask) ORDER BY submask DESC"
#define NASACLSQL "SELECT value1 FROM acl WHERE id=%d AND value IN ('%s', '%s') AND type=2 ORDER BY seq"

#if defined(DB_MYSQL)
#include <mysql.h>
typedef MYSQL DBH;
typedef MYSQL_ROW DB_ROW;
typedef MYSQL_RES DB_RES;
#endif

#if defined(DB_PGSQL)
#include <libpq-fe.h>
#define PWLEN   13
typedef PGresult DB_RES;
typedef struct {
	Gconn *conn;
	DB_RES *res;
} DBH;
#endif

#define DEFAULT_DB_TABLE_NAME "user"
#define DEFAULT_DB_FIELD_NAME_USER   "uid"
#define DEFAULT_DB_FIELD_NAME_PASSWD "password" 

struct tac_dbinfo {
	char	*type;
	char	*user;
	char	*password;
	char	*host;
	char	*database;		/* Database to use */
	char	*table;
	char	*field_name;
	char	*field_passwd;
};

typedef struct tac_dbinfo TAC_DBINFO;

int db_author();
#endif 
#endif /* USE_DB */
