# This file created by Andrew Young<baram01@hotmail.com>
# For creating tac_plus tables and upgrade others

USE tacacs;

CREATE TABLE acl ( id INT(4) NOT NULL, type INT(1) NOT NULL,
        seq INT(4) NOT NULL, permission INT(2) NOT NULL,
        value VARCHAR(20) NOT NULL, value1 REAL, submask REAL,
	PRIMARY KEY (id, type, seq) );
                                                                                
CREATE TABLE host (ip varchar(20) NOT NULL PRIMARY KEY, hkey varchar(20),
		enable varchar(20), prompt TEXT, network real NOT NULL,
		submask real NOT NULL, loginacl INT(4), enableacl INT(4),
		INDEX net (network), INDEX sub (submask) );

CREATE TABLE user (uid varchar(20) NOT NULL PRIMARY KEY, gid varchar(20),
		comment text, password varchar(35), enable varchar(35),
		gpassword varchar(35), arap varchar(35), pap varchar(35),
		chap varchar(35), mschap varchar(35), expires datetime,
		b_author varchar(20), a_author varchar(20), svc_dflt int(4),
		maxsess int(4), user int(1), acl_id int(4), sess int(4));

CREATE TABLE node ( uid varchar(20) NOT NULL PRIMARY KEY, seq int(4) NOT NULL,
		service int(4) NOT NULL, type int(4), value varchar(50),
		value1 varchar(50), dflt int(4), INDEX service(uid, service),
		INDEX command(uid, service, value));

CREATE TABLE contact_info ( uid varchar(20) NOT NULL PRIMARY KEY,
		fname varchar(40) NOT NULL, surname varchar(40) NOT NULL,
		address1 varchar(40), address2 varchar(40), city varchar(30),
		state char(2), zip char(5), phone varchar(14));

CREATE TABLE accounting( date datetime, nas varchar(16) NOT NULL,
		uid varchar(20) NOT NULL, terminal varchar(20),
		client_ip varchar(16) NOT NULL, type varchar(20),
		service varchar(20), priv_lvl INT(2), cmd varchar(255),
		elapsed_time INT(6), bytes_in INT(10), bytes_out INT(10),
		INDEX date_index(date), INDEX acct_index(uid),
		INDEX nas_index(nas), INDEX client_index(client_ip));

CREATE TABLE access( date datetime NOT NULL, nas VARCHAR(16) NOT NULL,
		terminal VARCHAR(20), uid VARCHAR(20) NOT NULL,
		client_ip VARCHAR(16) NOT NULL, service VARCHAR(10),
		status VARCHAR(10), INDEX nas_index (nas),
		INDEX uid_index (uid), INDEX client_index (client_ip) );

CREATE TABLE admin ( uid varchar(20) NOT NULL PRIMARY KEY,
password VARCHAR(35) NOT NULL, priv_lvl INT(2), link INT(1));

INSERT INTO user ( uid, ENCRYPT(password), expires ) SELECT usern, passwd, exp_time FROM auth;
INSERT INTO contact_info ( uid, fname, surname, address1, phone ) SELECT usern, name, surname, address, tel FROM id;
INSERT INTO accounting ( uid, nas, client_ip, elapsed_time, bytes_in, bytes_out, date, cmd ) SELECT * FROM acct;
INSERT INTO TABLE admin VALUES ('admin',ENCRYPT('system'), 15, 0);
GRANT ALL ON tacacs.* TO tacacs@localhost IDENTIFIED BY 'tac_plus';
GRANT ALL ON tacacs.* TO tacacs IDENTIFIED BY 'tac_plus';

DROP TABLE auth;
DROP TABLE id;
DROP TABLE acct;

