#!/usr/bin/perl
#
# Description:  Use to load accounting file into tacacs database
# Requirements: Perl 5 and above
#               Perl DBI
#               Perl DBI::mysql
#
# Written by:   Andrew Young (baram@rcn.com)
#
use Time::Local;
use DBI;

if ($#ARGV+1 < 1) {
	print "Usage: upload_acct.pl <accounting file>\n";
	exit 1;
}

local($acctfile)=$ARGV[0];
local($dbuser)="tacacs";
local($dbpass)="tac_plus";
$months["Jan"]=1;
$months["Feb"]=2;
$months["Mar"]=3;
$months["Apr"]=4;
$months["May"]=5;
$months["Jun"]=6;
$months["Jul"]=7;
$months["Aug"]=8;
$months["Sep"]=9;
$months["Oct"]=10;
$months["Nov"]=11;
$months["Dec"]=12;
$i = 0;

$dbh = DBI->connect("DBI:mysql:database=tacacs", $dbuser, $dbpass) ||
	die "User $dbuser is not allowed\n";
$sth = $dbh->prepare("INSERT INTO accounting2 VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)");
open(IN, "$acctfile") || die "Cannot find file $acctfile\n";
while (<IN>) {
	print "$i\n";
	($todate, $nas, $uid, $terminal, $client_ip, $type, @record) = split(/\t/,$_);
	($mday, $month, $day, $time, $year) = split(/\s+/, $todate);
	($hour, $min, $sec) = split(/:/,$time);
	$date = "$year-$months[$month]-$day $hour:$min:$sec";
	print "$date\n";
#	$date = timelocal(int($sec),int($min),int($hour),int($day),int($months[$month]),int($year));
	foreach $value (@record) {
		if ($value =~ /priv/) {
			($a, $priv_lvl) = split(/=/,$value);
		} elsif ($value =~ /bytes-in/) {
			($a, $bytes_in) = split(/=/,$value);
		} elsif ($value =~ /bytes-out/) {
			($a, $bytes_out) = split(/=/,$value);
		} elsif ($value =~ /cmd/) {
			($a, $cmd) = split(/=/, $value);
		} else {
			eval "\$$value" || print "Cannot eval $value\n";
		}
	}
	$sth->execute($date, $nas, $uid, $terminal, $client_ip, $type, $service, $priv_lvl, $cmd, $elapsed_time, $bytes_in, $bytes_out) || print "Cannot execute\n";
	$i++;
}

